local _, addon = ...
local floor, ceil = math.floor, math.ceil

local data = addon.data
local createdtex = 0
local totaltex = 0

local oldclose = WorldMapFrameCloseButton:GetScript("OnClick")
WorldMapFrameCloseButton:RegisterForClicks("LeftButtonUp", "RightButtonUp")
WorldMapFrameCloseButton:SetScript("OnClick", function(WorldMapFrameCloseButton, button)
	if button == "RightButton" then
		if ncExploreMap then
			ncExploreMap = false

			if totaltex > 0 then
				for i = 1, totaltex do
					_G["WorldMapOverlay"..i]:Hide()
				end
				totaltex = 0
			end

			if WorldMapFrame:IsShown() then
				WorldMapFrame_Update()
			end
		else
			ncExploreMap = true

			if WorldMapFrame:IsShown() then
				WorldMapFrame_Update()
			end
		end
	else
		oldclose(WorldMapFrameCloseButton, button)
	end
end)

hooksecurefunc("WorldMapFrame_Update", function()
	if not WorldMapFrame:IsShown() or not ncExploreMap then return end
	if totaltex > 0 then
		for i = 1, totaltex do _G["WorldMapOverlay"..i]:Hide() end
		totaltex = 0
	end

	local filename, texheight = GetMapInfo()
	if not filename then return end

	local prefix = format([[Interface\WorldMap\%s\]], filename)
	local len = strlen(prefix) + 1
	local zone = data[filename] or {}
	local explored = {}
	
	local len2 = strlen("Interface\\WorldMap\\"..filename) + 2
	for i=1, GetNumMapOverlays() do
		local name2 = GetMapOverlayInfo(i)
	end

	for tname, num in next, zone do
		local texturename = prefix .. tname
		local texwidth, texheight, offsetx, offsety = num % 1024, floor(num / 1024) % 1024, floor(num / 1048576) % 1024, floor(num / 1073741824)

		if texturename == "Interface\\WorldMap\\Tirisfal\\BRIGHTWATERLAKE" then
			if offsetx == 587 then
				offsetx = 584
			end
		elseif texturename == "Interface\\WorldMap\\Silverpine\\BERENSPERIL" then
			if offsety == 417 then
				offsety = 415
			end
		end
		
		local numtexwide = ceil(texwidth / 256)
		local numtextall = ceil(texheight / 256)
		local neededtex = totaltex + numtexwide * numtextall

		if neededtex > createdtex then
			for j = createdtex + 1, neededtex do
				WorldMapDetailFrame:CreateTexture("WorldMapOverlay"..j, "ARTWORK")
			end
			createdtex = neededtex
		end

		for j = 1, numtextall do
			local texturepxheight, texturefileheight
			if j < numtextall then
				texturepxheight = 256
				texturefileheight = 256
			else
				texturepxheight = texheight % 256
				if texturepxheight == 0 then
					texturepxheight = 256
				end
				texturefileheight = 16
				while texturefileheight < texturepxheight do
					texturefileheight = texturefileheight * 2
				end
			end
			for k = 1, numtexwide do
				if totaltex > createdtex then return end
				totaltex = totaltex + 1
				local texture = _G["WorldMapOverlay"..totaltex]
				local texturepxwidth
				local texturefilewidth
				if k < numtexwide then
					texturepxwidth = 256
					texturefilewidth = 256
				else
					texturepxwidth = texwidth % 256
					if texturepxwidth == 0 then
						texturepxwidth = 256
					end
					texturefilewidth = 16
					while texturefilewidth < texturepxwidth do
						texturefilewidth = texturefilewidth * 2
					end
				end
				texture:SetWidth(texturepxwidth)
				texture:SetHeight(texturepxheight)
				texture:SetTexCoord(0, texturepxwidth/texturefilewidth, 0, texturepxheight/texturefileheight)
				texture:ClearAllPoints()						  
				texture:SetVertexColor(1, 1, 1)
				texture:SetPoint("TOPLEFT", "WorldMapDetailFrame", "TOPLEFT", offsetx + (256 * (k-1)), -(offsety + (256 * (j - 1))))
				texture:SetTexture(texturename..(((j - 1) * numtexwide) + k))
				texture:Show()
			end
		end 
	end
end)

if WorldMapFrame:IsShown() then WorldMapFrame_Update() end

-- clear data of already discovered zones
for mapid = 1, 1000 do
	SetMapByID(mapid)

	local filename = GetMapInfo()
	if GetCurrentMapAreaID() == mapid+1 and filename and data[filename] then
		local len = strlen("Interface\\WorldMap\\"..filename) + 2
	
		for i=1, GetNumMapOverlays() do
			local name = GetMapOverlayInfo(i)
			data[filename][string.sub(name, len)] = nil
		end

		if not next(data[filename]) then
			data[filename] = nil
		end

	end
end
